#ifndef CHECK_H
#define CHECK_H

#include <eo>
#include <iostream>   // cout
#include "fitness.h" 

using namespace std;


class MyCheck : public eoContinue<PaletteIndividual> {

public:
  
  MyCheck(Picture& _target, int _period = 100) : target(_target) { 
    period = _period; 
    iter = 0; 
  } 

  virtual bool operator()(const eoPop<PaletteIndividual>& _pop) {
    cout << _pop.best_element().fitness() << endl; 
    iter++;
    if ( !(iter % period) ) {
      Picture dest; 
      string fname = "result"; 
      sprintf(buf,"%d",iter);
      fname += buf;
      fname += ".png";
      dest.setFileName(fname);
      dest.create( _pop.best_element().palette, target); 
      dest.save();
    } 
      
    return true; 
  }; 

private:
  int iter; 
  int period; 
  Picture& target; 
  char buf[100]; 
};  

#endif
